Attribute VB_Name = "QuickHook"
Option Explicit

Public Type HookData
    pFunction   As Long     ' Pointer zur umzuleitenden Stelle
    pNewFnc     As Long     ' Umleitungsziel
    cHookSize   As Long     ' Gre des Hooks
    pBackup     As Long     ' Pointer zu gesicherten Bytes
    cBackupSize As Long     ' Menge an gesicherten Bytes
    valid       As Boolean  ' Hook funktional?
End Type

Public Type MachineCode
    pAsm        As Long     ' Pointer zum Code
    cSize       As Long     ' Gre des Codes in Bytes
    valid       As Boolean  ' gltig?
End Type

Private Declare Function VirtualAlloc Lib "kernel32" ( _
    lpAddress As Any, _
    ByVal dwSize As Long, _
    ByVal flAllocationType As Long, _
    ByVal flProtect As Long _
) As Long

Private Const MEM_COMMIT                As Long = &H1000

Private Declare Function VirtualFree Lib "kernel32" ( _
    lpAddress As Any, _
    ByVal dwSize As Long, _
    ByVal dwFreeType As Long _
) As Long

Private Const MEM_DECOMMIT              As Long = &H4000

Private Declare Function VirtualProtect Lib "kernel32" ( _
    lpAddress As Any, _
    ByVal dwSize As Long, _
    ByVal flNewProtect As Long, _
    ByRef lpflOldProtect As Long _
) As Long

Private Const PAGE_EXECUTE              As Long = &H10
Private Const PAGE_EXECUTE_READ         As Long = &H20
Private Const PAGE_EXECUTE_READWRITE    As Long = &H40

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    pDst As Any, pSrc As Any, ByVal cBytes As Long _
)

Private Declare Sub FillMemory Lib "kernel32" Alias "RtlFillMemory" ( _
    pDst As Any, ByVal cBytes As Long, ByVal char As Byte _
)

Private Declare Function IsBadCodePtr Lib "kernel32" ( _
    ByVal addr As Long _
) As Long

Private Const IDE_ADDROF_REL            As Long = 22
Private Const ASMSIZE                   As Long = 5

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" ( _
    ByVal strPath As String _
) As Long

Private Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" ( _
    ByVal strModule As String _
) As Long

Private Declare Function GetProcAddress Lib "kernel32" ( _
    ByVal hModule As Long, ByVal strName As String _
) As Long

Public Function GetWinAPIFunction(ByVal strLib As String, ByVal strFncName As String) As Long
    Dim hModule As Long
    
    hModule = GetModuleHandle(strLib)
    If hModule = 0 Then
        hModule = LoadLibrary(strLib)
        If hModule = 0 Then Exit Function
    End If
    
    GetWinAPIFunction = GetProcAddress(hModule, strFncName)
End Function

' alloziert ausfhrbaren Speicher und schreibt
' als Hex String bergebenen Maschinencode hinein
Public Function ASMStringToMemory(ByVal strAsm As String) As MachineCode
    Dim btAsm() As Byte
    Dim i       As Long
    Dim udtMem  As MachineCode
    
    ReDim btAsm(Len(strAsm) \ 2 - 1) As Byte

    For i = 0 To Len(strAsm) \ 2 - 1
        btAsm(i) = CByte("&H" & Mid$(strAsm, i * 2 + 1, 2))
    Next

    With ASMStringToMemory
        .cSize = UBound(btAsm) + 1
        .pAsm = VirtualAlloc(ByVal 0&, .cSize, MEM_COMMIT, PAGE_EXECUTE_READWRITE)
        If .pAsm <> 0 Then
            CopyMemory ByVal .pAsm, btAsm(0), .cSize
            .valid = True
        End If
    End With
End Function

Public Function FreeASMMemory(asm As MachineCode) As Boolean
    If asm.valid Then
        asm.valid = False
        FreeASMMemory = VirtualFree(ByVal asm.pAsm, asm.cSize, MEM_DECOMMIT) <> 0
    End If
End Function

' Mit Jmp Instruktion berschriebene Funktion wiederherstellen
Public Function RestoreFunction(hook As HookData) As Boolean
    Dim lngOldProtection    As Long
    Dim lngRet              As Long
    
    If hook.valid Then
        lngRet = VirtualProtect(ByVal hook.pFunction, hook.cHookSize, _
            PAGE_EXECUTE_READWRITE, lngOldProtection)
        
        If lngRet = 0 Then Exit Function
        
        CopyMemory ByVal hook.pFunction, ByVal hook.pBackup, ByVal hook.cBackupSize
        
        VirtualProtect ByVal hook.pFunction, hook.cHookSize, lngOldProtection, 0&
        VirtualFree ByVal hook.pBackup, hook.cBackupSize, MEM_DECOMMIT
        
        hook.valid = False
        RestoreFunction = True
    End If
End Function

' Funktion mit Jmp Instruktion berschreiben,
' mit Untersttzung fr VB 6 IDE
Public Function RedirectFunction(ByVal addr_in As Long, ByVal isVBModule As Boolean, _
    ByVal addr_out As Long) As HookData
    
    Dim lngBackupMemory     As Long
    Dim lngOldInProtection  As Long
    Dim lngRet              As Long
    Dim lngJmp              As Long
    Dim btAsm(ASMSIZE - 1)  As Byte
    
    If isVBModule Then addr_in = VBGetFunctionPointer(addr_in)
    
    lngBackupMemory = VirtualAlloc(ByVal 0&, ASMSIZE, MEM_COMMIT, PAGE_EXECUTE_READWRITE)
    If lngBackupMemory = 0 Then Exit Function
    
    lngRet = VirtualProtect(ByVal addr_in, ASMSIZE, PAGE_EXECUTE_READWRITE, lngOldInProtection)
    If lngRet = 0 Then
        VirtualFree ByVal lngBackupMemory, ASMSIZE, MEM_DECOMMIT
        Exit Function
    End If
    
    CopyMemory ByVal lngBackupMemory, ByVal addr_in, ASMSIZE
    
    lngJmp = addr_out - addr_in - ASMSIZE
    
    btAsm(0) = &HE9
    CopyMemory btAsm(1), lngJmp, 4
    
    CopyMemory ByVal addr_in, btAsm(0), ASMSIZE
    
    lngRet = VirtualProtect(ByVal addr_in, ASMSIZE, lngOldInProtection, 0&)
'    If lngRet = 0 Then
'        VirtualFree ByVal lngBackupMemory, ASMSIZE, MEM_DECOMMIT
'        Exit Function
'    End If
    
    With RedirectFunction
        .pFunction = addr_in
        .pNewFnc = addr_out
        .pBackup = lngBackupMemory
        .cBackupSize = ASMSIZE
        .cHookSize = ASMSIZE
        .valid = True
    End With
End Function

Private Function VBGetFunctionPointer(ByVal addrof As Long) As Long
    Dim pAddr As Long
    
    If IsRunningInIDE_DirtyTrick() Then
        ' Wird das Programm aus der Entwicklungsumgebung heraus
        ' ausgefhrt, befindet sich der eigentliche Zeiger auf
        ' eine Funktion bei (AddressOf X) + 22, AddressOf X
        ' selber zeigt nur auf einen Stub. (getestet mit VB 6)
        CopyMemory pAddr, ByVal addrof + IDE_ADDROF_REL, 4
        If IsBadCodePtr(pAddr) <> 0 Then pAddr = addrof
    Else
        pAddr = addrof
    End If
    
    VBGetFunctionPointer = pAddr
End Function

' http://www.activevb.de/tipps/vb6tipps/tipp0347.html
Private Function IsRunningInIDE_DirtyTrick() As Boolean
  On Error GoTo NotCompiled
  
    Debug.Print 1 / 0
    Exit Function
    
NotCompiled:
    IsRunningInIDE_DirtyTrick = True
    Exit Function
End Function
